SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")

local frame = CreateFrame("Frame", "SortGroupPanel", UIParent);
local CRFSort_Group;
-- Main Frame

GroupDown = false;
GroupUp = false;
GroupAutoActivate = false;
raidProfile = nil;
RegardlessRaidProfile = false;
cacheAutoActive = nil;
-- Chosen Options
-- cacheAutoActive intern cache for AutoActivate

enterBattleground = false;
-- true when "PLAYER_ENTERING_BATTLEGROUND" fired

loginScreen = false;
-- true when "PLAYER_ENTERING_WORLD" fired or cbup/cbdown are checked

inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired

local cBDown = CreateFrame("CheckButton", "CheckButtonDown_Text", frame, "UICheckButtonTemplate");
local cBUp = CreateFrame("CheckButton", "CheckButtonUp_Text", frame, "UICheckButtonTemplate");
local cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", frame, "UICheckButtonTemplate");
local cbRegardlessRaidProfile = CreateFrame("CheckButton", "CheckButtonRegardlessRaidProfile_Text", frame, "UICheckButtonTemplate");
-- Combo-box Options

local btnReload = CreateFrame("Button", "Button_Text", frame, "UIPanelButtonTemplate");
-- Reload Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", frame, "UIDropDownMenuTemplate");
ddmItems = {};
-- DropDownMenu

local mapID = {
	401,461,935,482,540,860,
	512,856,736,626,443,
	};
-- battleground Map IDs

local defaultColor = "#FFFFFF";

local function createFrame()	
	frame.name = "SortGroup";
	font = frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	font:SetFont("Fonts\\FRIZQT__.TTF", 18);
	font:SetTextColor(1, 0.8, 0);
    font:SetPoint("TOPLEFT", 12, -18);
    font:SetText("SortGroup");
	InterfaceOptions_AddCategory(frame);
	frame.cancel = function(self)
		if ( GetNumGroupMembers() > 1 ) then
			if ( GroupDown == true or GroupUp == true ) then
				print(ColorPrint(L["ESC_In_Group"], "option"));
			end
		end
		if ( inCombat == false ) then
			loginScreen = false;
			SendSortOptionToSortBy(false);
		end
	end
end

local function frameEvent()
	frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				SortGroupInformation.Down = GroupDown;
				SortGroupInformation.Up = GroupUp;
				SortGroupInformation.Profile = raidProfile;
				SortGroupInformation.AutoActivate = GroupAutoActivate;
				SortGroupInformation.RegardlessRaidProfile = RegardlessRaidProfile;
				frame:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				inCombat = false;
			elseif ( event == "ACTIVE_TALENT_GROUP_CHANGED" and HasLoadedCUFProfiles() == true and GroupAutoActivate == true ) then
				loginScreen = false;
				SendSortOptionToSortBy(false);
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
				end				
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
				end				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = true;
				end				
				if ( SortGroupInformation.RegardlessRaidProfile == nil ) then
					SortGroupInformation.RegardlessRaidProfile = false;
				end			
				GroupDown = SortGroupInformation.Down;
				GroupUp = SortGroupInformation.Up;
				GroupAutoActivate = SortGroupInformation.AutoActivate;
				RegardlessRaidProfile = SortGroupInformation.RegardlessRaidProfile;
				if ( ReadAllRaidProfiles(SortGroupInformation.Profile) == false ) then
					cache = L["RaidProfil_dont_exists"]:gsub("'replacement'", SortGroupInformation.Profile);
					SortGroupInformation.Profile = GetRaidProfileName(1);
					print(ColorPrint(cache:gsub("'replacement2'", SortGroupInformation.Profile),"option"));
					UIDropDownMenu_SetText(ddmProfiles, raidProfile);
				end
				raidProfile = SortGroupInformation.Profile;
				UIDropDownMenu_SetText(ddmProfiles, raidProfile)
				ChangesComboBoxes();
				--Get informations
				
				loginScreen = true;
				SendSortOptionToSortBy(false);		
				-- Start sort
				frame:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and inCombat == false) then	
				loginScreen = false;
				SendSortOptionToSortBy(false);
			end
		end);
end

local function createCheckbox()		
	cBDown:SetPoint("TOPLEFT", 10, -60);
	cBUp:SetPoint("TOPLEFT",10, -100);
	cbAutoActivate:SetPoint("TOPLEFT",300,-90);
	cbRegardlessRaidProfile:SetPoint("TOPLEFT",270,-60);
	
	getglobal(cBDown:GetName() .. 'Text'):SetText(L["cBDown_Option_Text"]);
	getglobal(cBUp:GetName() .. 'Text'):SetText(L["cBUp_Option_Text"]);
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
	getglobal(cbRegardlessRaidProfile:GetName() .. 'Text'):SetText(L["cbRegardlessRaidProfile_Text"]);
end

local function checkBoxEvent()
	cBDown:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = true;
				if ( cBDown:GetChecked() == true ) then
					GroupDown = true;
					GroupUp = false;
					cBUp:SetChecked(false);
				elseif ( cBDown:GetChecked() == false ) then	
					GroupDown = false;
				end
				SendSortOptionToSortBy(true);
			else
				ChangesComboBoxes();
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end);		
	cBDown:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBDown_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBDown:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Down
		
	cBUp:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = true;
				if ( cBUp:GetChecked() == true ) then
					GroupDown = false;
					GroupUp = true;
					cBDown:SetChecked(false);
				elseif ( cBUp:GetChecked() == false ) then	
					GroupUp = false;
				end
				SendSortOptionToSortBy(true);
			else
				ChangesComboBoxes();
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end);
	cBUp:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBUp_ToolTip_text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBUp:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Up
		
	cbAutoActivate:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = true;
				if ( cbAutoActivate:GetChecked() == true ) then
					GroupAutoActivate = true;
				elseif ( cbAutoActivate:GetChecked() == false ) then
					GroupAutoActivate = false;
				end
				SendSortOptionToSortBy(true);
			else
				ChangesComboBoxes(true);
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox AutoActive
		
	cbRegardlessRaidProfile:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				loginScreen = true;
				if ( cbRegardlessRaidProfile:GetChecked() == true ) then
					RegardlessRaidProfile = true;
					cacheAutoActive = AutoActivate;
					AutoActivate = false;
					UIDropDownMenu_DisableDropDown(ddmProfiles);
					cbAutoActivate:Disable();
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"],"disable"));
				elseif ( cbRegardlessRaidProfile:GetChecked() == false ) then
					RegardlessRaidProfile = false;
					AutoActivate = cacheAutoActive;
					cbAutoActivate:Enable();
					UIDropDownMenu_EnableDropDown(ddmProfiles);
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
				end
				SendSortOptionToSortBy(true);
			else
				ChangesComboBoxes();
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end);		
	cbRegardlessRaidProfile:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbRegardlessRaidProfile_Tooltip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox RegardlessRaidProfile
end
--ComboBox Events

function SendSortOptionToSortBy(InGroupCheck)
	if	( CheckMapID() == true ) then
		if ( RegardlessRaidProfile == false ) then
			if ( GroupDown == true or GroupUp == true ) then
				if ( ReadAllRaidProfiles(raidProfile) == false ) then
					cache = L["RaidProfil_dont_exists"]:gsub("'replacement'", raidProfile);
					raidProfile = GetRaidProfileName(1);
					print(ColorPrint(cache:gsub("'replacement2'", raidProfile), "option"));
					UIDropDownMenu_SetText(ddmProfiles, raidProfile);
				end
			end
		end
		if ( InGroupCheck == true ) then
			if ( InGroupText() == true ) then
			loginScreen = false;
			end
		end
		if ( GroupDown == true ) then
			SortBy('Down', raidProfile);
		elseif ( GroupUp == true ) then
			SortBy('Up', raidProfile);
		else
			if ( loginScreen == true ) then
				print (ColorPrint(L["sort_no"], "option"));
				loginScreen = false;
			end
		end
	elseif ( loginScreen == true ) then
		print(ColorPrint(L["In_BG"], "option"));
		loginScreen = false;
	end
end
--Stop between SortBy

local function createButton()
	btnReload:SetSize(84, 24);
	btnReload:SetText(L["btn_Option_text"]);
	btnReload:SetPoint("TOPLEFT", 10, -160);
end

local function buttonEvent()
	btnReload:SetScript("OnClick", 
		function()
			if ( inCombat == false ) then
				ReloadUI();
			end
		end);
end

local function createDropDownMenu()
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", 290, -125);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( inCombat == false and level == 1 ) then
			wipe(self.info);
			ReadAllRaidProfiles();
			for i, value in pairs(ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					raidProfile = value;
					UIDropDownMenu_SetText(ddmProfiles, raidProfile);
					loginScreen = true;
					SendSortOptionToSortBy(true);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
			end
		else
			print(ColorPrint(L["in_combat_options"], "option"));
		end
	end
	ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["ddmProfiles_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
end
--DropDownMenu creating, include items

function SortDown()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end
	
function SortUp()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end

function SortBy(SortOption, RaidProfileName)	
	if ( RaidProfileName ~= nil and GetNumGroupMembers() < 5 and HasLoadedCUFProfiles() == true) then
		if ( GetActiveRaidProfile() ~= RaidProfileName and GroupAutoActivate == true and RegardlessRaidProfile == false) then
			CompactUnitFrameProfiles_ActivateRaidProfile(RaidProfileName);
		end
		if ( GetActiveRaidProfile() ~= RaidProfileName and GroupAutoActivate == false and RegardlessRaidProfile == false ) then
			if ( loginScreen == true ) then
				print(ColorPrint(L["RaidProfil_Doesnt_match"], "option"));
				loginScreen = false;
			end
		elseif ( GetActiveRaidProfile() == RaidProfileName or RegardlessRaidProfile == true) then
			if ( SortOption == 'Down') then
				if ( loginScreen == true ) then
					if ( RegardlessRaidProfile == true ) then
						print(ColorPrint(L["sort_down_regardless"], "option"));
					else
						loginScreen = false;
						print(ColorPrint(L["sort_down"]:gsub("'replacement'", RaidProfileName), "option"));
					end
				end
				CheckRaidProfileOptions();
				SortDown();
			elseif ( SortOption == 'Up') then
				if ( loginScreen == true ) then
					if ( RegardlessRaidProfile == true ) then
						print(ColorPrint(L["sort_up_regardless"], "option"));
					else
						loginScreen = false;
						print(ColorPrint(L["sort_up"]:gsub("'replacement'", RaidProfileName), "option"));
					end
				end
				CheckRaidProfileOptions();
				SortUp();
			end
		end		
	end
end

function InGroupText()
	if ( GetNumGroupMembers() > 1 ) then
		print(ColorPrint(L["Currently_in_a_group"], "option"));
		return true;
	end
	return false;
end

function CheckRaidProfileOptions()
	if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
		CompactUnitFrameProfilesRaidStylePartyFrames:Click(true);
	end
	if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
		CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);		
	end
end
--necessary changes, otherwise there is no sort

function ReadAllRaidProfiles(raidProfile)
	raidprofilexists = false;
	for i=1, GetNumRaidProfiles(), 1 do
		ddmItems[i] = GetRaidProfileName(i);
		if ( ddmItems[i] == raidProfile ) then
			raidprofilexists = true;
		end
	end
	if ( raidprofilexists == true ) then
		return true;
	end
	return false;
end
--Fills ddmItems with raidprofiles and checks if raidprofil exists

function ChangesComboBoxes()
	if ( GroupAutoActivate == true ) then
		cbAutoActivate:SetChecked(true);
	else
		cbAutoActivate:SetChecked(false);
	end
	if ( RegardlessRaidProfile == true ) then
		cacheAutoActive = AutoActivate;
		AutoActivate = false;
		UIDropDownMenu_DisableDropDown(ddmProfiles);
		cbAutoActivate:Disable();
		cbRegardlessRaidProfile:SetChecked(true);
	else
		RegardlessRaidProfile = false;
		AutoActivate = cacheAutoActive;
		cbAutoActivate:Enable();
		if ( cbAutoActivate:GetChecked() == true ) then
			UIDropDownMenu_EnableDropDown(ddmProfiles);
		end
		cbRegardlessRaidProfile:SetChecked(false);
	end
	if ( GroupDown == true ) then
		cBDown:SetChecked(true);
		cBUp:SetChecked(false);
	elseif ( GroupUp == true ) then
		cBDown:SetChecked(false);
		cBUp:SetChecked(true);
	else
		cBDown:SetChecked(false);
		cBUp:SetChecked(false);
	end
end
--In combat no changes

function CheckMapID()
	areaid = GetCurrentMapAreaID();
	for i, v in ipairs(mapID) do
		if ( areaid == v ) then
			return false;
		end
	end
	return true;
end

function ColorPrint(text, operation)
	if ( operation == "option" ) then
		cacheText = text:gsub("SortGroup:" , function(cap)
			cap = cap:sub(1, -1);
			local color = "|cff00FF7F" or defaultColor
			return color..cap.."|r"
		end)
		return cacheText
	elseif ( operation == "disable" ) then
		local color = "|cff888888" or defaultColor
		return color..text
	end
end

function StartAddon()
	createFrame();
	createCheckbox();
	checkBoxEvent();
	createButton();
	buttonEvent();
	frameEvent();
	createDropDownMenu();	
end
StartAddon();